"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stddev = exports.mean = exports.sum = exports.takeLast = exports.takeField = void 0;

var takeField = function takeField(arr, field) {
  return arr.map(function (x) {
    return field ? x[field] : x;
  });
};

exports.takeField = takeField;

var takeLast = function takeLast(arr, n, field) {
  return takeField(arr.slice(n > arr.length ? 0 : arr.length - n, arr.length), field);
};

exports.takeLast = takeLast;

var sum = function sum(data) {
  return data.reduce(function (acc, x) {
    return acc + x;
  });
};

exports.sum = sum;

var mean = function mean(data) {
  return data.reduce(function (a, b) {
    return a + b;
  }) / data.length;
};

exports.mean = mean;

var stddev = function stddev(data) {
  var dataMean = mean(data);
  var sqDiff = data.map(function (n) {
    return Math.pow(n - dataMean, 2);
  });
  var avgSqDiff = mean(sqDiff);
  return Math.sqrt(avgSqDiff);
};

exports.stddev = stddev;